s([s,NP,VPB])-->np(NP),vpb(VPB).
s([s,NPA,VPA])-->npa(NPA),vpa(VPA).
s([s,NPA,VP])-->npa(NPA),vp(VP).
s([s,NP,VP])-->np(NP),vp(VP).
s([s,NP,VPA])-->np(NP),vpa(VPA).
s([s,NP,VPB])-->np(NP),vpb(VPB).
s([s,NP,VPC])-->np(NP),vpc(VPC).
s([s,PP,VPA])-->pp(PP),vpa(VPA).
s([s,ADV,NP,VPA])-->adv(ADV),np(NP),vpa(VPA).
s([s,ADV,NP,VPB])-->adv(ADV),np(NP),vpb(VPB).
s([s,SA,COMMA,SA])-->sa(SA),comma(COMMA),sa(SA).
s([s,SA,SA])-->sa(SA),sa(SA).
sa([s,SB,S])-->sb(SB),s(S).
sa([s,VPA,S])-->vpa(VPA),s(S).
sa([s,ADV,COMMA,S])-->adv(ADV),comma(COMMA),s(S).
sa([s,ADV,S])-->adv(ADV),s(S).
sa([s,NP,VPA])-->np(NP),vpa(VPA).
sa([s,NP,VP])-->np(NP),vp(VP).
sb([s,NP,VPA])-->np(NP),vpa(VPA).
sb([s,ADV,SA])-->adv(ADV),sa(SA).
sc([s,NP,VPB])-->np(NP),vpb(VPB).

%"k" is explained in the readme.txt file
k([s,S,COMMA,S])-->s(S),comma(COMMA),s(S).
k([s,ADV,COMMA,S])-->adv(ADV),comma(COMMA),s(S).
k([s,ADV,S])-->adv(ADV),s(S).

np([np,N])-->n(N).
np([np,N,N])-->n(N),n(N).
np([np,N,ADJ])-->n(N),adj(ADJ).
np([np,DET,N])-->det(DET),n(N).
np([np,DET,ADVA,N])-->det(DET),adva(ADVA),n(N).
np([np,DET,ADV,N])-->det(DET),adv(ADV),n(N).
np([np,DET,ADJ,N])-->det(DET),adj(ADJ),n(N).
np([np,ADJ,N])-->adj(ADJ),n(N).
np([np,ADJA,N])-->adja(ADJA),n(N).
np([np,ADV,N])-->adv(ADV),n(N).
np([np,ADVA,N])-->adva(ADVA),n(N).
np([np,ADVB,N])-->advb(ADVB),n(N).
npa([np,NP,N])-->np(NP),n(N).
npa([np,NP,ADVA])-->np(NP),adva(ADVA).
npa([np,NP,NP])-->np(NP),np(NP).
npa([np,ADV,NP])-->adv(ADV),np(NP).
npa([np,ADJ,NP])-->adj(ADJ),np(NP).
npa([np,NP,PP])-->np(NP),pp(PP).
npa([np,NP,CONJ,NP])-->np(NP),conj(CONJ),np(NP).
npb([np,NPA,NPA])-->npa(NPA),npa(NPA).

vp([vp,V])-->v(V).
vp([vp,ADV,V])-->adv(ADV),v(V).
vp([vp,ADVA,V])-->adva(ADVA),v(V).
vp([vp,V,ADVA])-->v(V),adva(ADVA).
vp([vp,V,PP,NP])-->v(V),pp(PP),np(NP).
vp([vp,PP,VPC])-->pp(PP),vpc(VPC).
vpa([vp,VP,NPA])-->vp(VP),npa(NPA).
vpa([vp,VP,ADVA])-->vp(VP),adva(ADVA).
vpa([vp,VP,V])-->vp(VP),v(V).
vpa([vp,VP,ADV])-->vp(VP),adv(ADV).
vpa([vp,VP,VP])-->vp(VP),vp(VP).
vpa([vp,VP,NP])-->vp(VP),np(NP).
vpa([vp,VP,PP])-->vp(VP),pp(PP).
vpa([vp,ADV,VP])-->adv(ADV),vp(VP).
vpa([vp,ADVB,VP])-->advb(ADVB),vp(VP).
vpa([vp,VP,PP])-->vp(VP),pp(PP).
vpb([vp,VPA,PP])-->vpa(VPA),pp(PP).
vpb([vp,VPA,NP])-->vpa(VPA),np(NP).
vpb([vp,VPA,CONJ,VPA])-->vpa(VPA),conj(CONJ),vpa(VPA).
vpc([vp,VPB,NPB])-->vpb(VPB),npb(NPB).
vpc([vp,V,VPB])-->v(V),vpb(VPB).

adva([adv,ADV,ADJB])-->adv(ADV),adjb(ADJB).
adva([adv,ADV,ADV])-->adv(ADV),adv(ADV).
adva([adv,ADV,ADJ])-->adv(ADV),adj(ADJ).
advb([adv,ADV,ADVA])-->adv(ADV),adva(ADVA).
advb([adv,ADVA,ADV])-->adva(ADVA),adv(ADV).

adja([adj,ADJ,ADJ])-->adj(ADJ),adj(ADJ).
adja([adj,ADJ,ADV])-->adj(ADJ),adv(ADV).
adjb([adj,ADJA,ADJ])-->adja(ADJA),adj(ADJ).

pp([pp,P,NP])-->p(P),np(NP).
pp([pp,P,NPA])-->p(P),npa(NPA).
pp([pp,P,ADV,NP])-->p(P),adv(ADV),np(NP).

s(P,WL) :- s(P,WL,[]),write_term(P,[max_depth(0)]).
